///////////////////////////////////////////////////////////////////////////////
//
//  Vom Xbase++ FormDesigner generierter Klassen Code
//    Erstellt am: 19.09.08 Zeit: 05:08:32
//
//  Contents  :
//    Diese Datei enthlt das Gerst zur Implementierung der Nutzungsebene.
//    Daher kann und soll diese Datei verndert werden.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "xbpprogr.CH"

#include "Dll.ch"
#include "OS.ch"

#define WM_USER            0x0400

#define PBS_SMOOTH         0x01
#define PBS_VERTICAL       0x04
#define PBS_MARQUEE        0x08
#Define PBS_SMOOTHREVERSE  0x10

#define GWL_STYLE          (-16)

#Define WS_VISIBLE         0x10000000
#Define WS_CHILD           0x40000000

#Define PBM_SETSTATE       0x0410
#Define PBST_NORMAL        0x0001
#Define PBST_ERROR         0x0002
#Define PBST_PAUSED        0x0003

#define PBM_SETSTEP        (WM_USER+4)
#define PBM_STEPIT         (WM_USER+5)

#define PBM_SETBARCOLOR    (WM_USER+9)
#define PBM_SETMARQUEE     (WM_USER+10)

#IF XPPVER > 01900331
#ELSE
   #define XBP_STATE_NORMAL               1
   #define XBP_STATE_HOT                  2
   #define XBP_STATE_PRESSED              3
   #define XBP_STATE_DISABLED             4
   #define XBP_STATE_CUSTOM               128
#ENDIF

STATIC aStyles := {            ; // { "Name", max.Parts }
           {"Button"       , 5},;
           {"Rebar"        , 5},;
           {"Toolbar"      , 6},;
           {"Status"       , 3},;
           {"Menu"         , 6},;
           {"ListView"     , 5},;
           {"Header"       , 4},;
           {"Progress"     , 4},;
           {"Tab"          ,10},;
           {"Trackbar"     ,10},;
           {"Tooltips"     , 5},;
           {"TreeView"     , 3},;
           {"Spin"         , 4},;
           {"Page"         , 4},;
           {"Scrollbar"    ,10},;
           {"Edit"         , 2},;
           {"ComboBox"     , 1},;
           {"Taskbar Clock", 1},;
           {"Tray Notify"  , 2},;
           {"Taskbar"      , 8},;
           {"TaskBand"     , 3},;
           {"StartPanel"   ,11},;
           {"ExplorerBar"  ,12},;
           {"Spin"         , 4} }

DLLFUNCTION SendMessageA( nHwnd, nCmd, wParam, lParam) USING STDCALL FROM USER32.DLL
DLLFUNCTION GetWindowLongA(nHWnd,nIndex) USING STDCALL FROM USER32.DLL
DLLFUNCTION SetWindowLongA(nHWnd,nIndex,dwNewLong)   USING STDCALL FROM USER32.DLL

******************************************************************************
* Von der Darstellungsklasse abgeleitete Klasse zur Implementierung der
* Programmlogik. Die Instanzvariablen der einzelnen Objekte sind in der
* Klasse _NewForm deklariert.
******************************************************************************
CLASS NewForm FROM _NewForm
   EXPORTED:
      METHOD init
      METHOD create

      METHOD StartShow()
      METHOD ShowBar()
      METHOD SetTV()
      METHOD NormalShow()
      METHOD PauseShow()
      METHOD ErrorShow()
      METHOD CheckColor()
      METHOD CheckVersion()
      METHOD CheckMarquee()
      METHOD CheckSMOOTH()

      //
      // activeX Version
      //
      VAR nVersion
      //
      //  the Progressbar
      //
      VAR oProgress
      //
      //  handle of Progressbar
      //
      VAR hwndPB
      //
      // Style can only used by Version 5.82.xxxx
      //
      VAR lSetStyle
      //
      // original Style
      //
      VAR OrgStyle
      //
      // :StyleClass, :StylePart
      //
      VAR cStyle,nPart
      //
      // Checkbox
      //
      VAR lChkVert
      VAR lChksmooth
      VAR lChkreverse
      VAR lChkMarquee

      VAR aColor1
      VAR aColor2
      VAR aColor3
      VAR aColor4

      VAR lChkColor
      VAR lRBnormal
      VAR lRBerror
      VAR lRBpause

ENDCLASS

******************************************************************************
* Formular initialisieren
******************************************************************************
METHOD NewForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * Methode der Superklasse rufen
   ::_NewForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::title := "Xbase++ activeX Progressbar with Style"
   //
   // preselect Version 5
   //
   ::nVersion = 5
   //
   // Radiobutton
   //
   ::oRB5:selection  := .T.
   ::oRB6:selection  := .F.

   ::oRB5:selected         := {|| ::nVersion := 5 , ::CheckVersion() }
   ::oRB6:selected         := {|| ::nVersion := 6 , ::CheckVersion() }

   ::lSetStyle := .T.
   ::cStyle    := "Progress"
   ::nPart     := 1
   ::OrgStyle  := NIL

   ::aColor1   := {255,000,000}
   ::aColor2   := {000,255,000}
   ::aColor3   := {000,000,255}
   ::aColor4   := {255,138,025}

   ::oColor1RGB:setCaption("ab 25%")
   ::oColor2RGB:setCaption("ab 50%")
   ::oColor3RGB:setCaption("ab 75%")
   ::oColor4RGB:setCaption("Start / End")
   //
   // all Progressbar are invisible
   //
   ::oV5Bar:Visible  := .T.
   ::oV6BarH:visible := .T.
   ::oV6BarV:visible := .T.
   //
   // preselect Checkbox
   //
   ::lChkVert        := .F.
   ::lChksmooth      := .F.
   ::lChkreverse     := .F.
   ::lChkMarquee     := .F.
   ::lChkColor       := .F.

   ::oChkVert:selected     := {|| IF(::lChkVert   , ::lChkVert    := .F. , ::lChkVert    := .T.) }
   ::oChksmooth:selected   := {|| IF(::lChksmooth , ::lChksmooth  := .F. , ::lChksmooth  := .T.) }
   ::oChkreverse:selected  := {|| IF(::lChkreverse, ::lChkreverse := .F. , ::lChkreverse := .T.) }
   ::oChkMarquee:selected  := {|| IF(::lChkMarquee, ::lChkMarquee := .F. , ::lChkMarquee := .T.) }
   ::oChkcolor:selected    := {|| ::CheckColor()  }

   ::oRBnormal:selection   := .T.
   ::oRBerror:selection    := .F.
   ::oRBpause:selection    := .F.

   ::lRBnormal             := .F.
   ::lRBerror              := .F.
   ::lRBpause              := .F.

   ::oRBnormal:selected    := {|| ::lRBnormal  := .T. ,::lRBerror   := .F. , ::lRBpause   := .F., ::lChkColor  := .F. }
   ::oRBerror:selected     := {|| ::lRBnormal  := .F. ,::lRBerror   := .T. , ::lRBpause   := .F., ::lChkColor  := .F. }
   ::oRBpause:selected     := {|| ::lRBnormal  := .F. ,::lRBerror   := .F. , ::lRBpause   := .T., ::lChkColor  := .F. }

   ::oTree:alwaysShowSelection := .T.
   ::oTree:hasButtons := .T.
   ::oTree:hasLines   := .T.

   ::oPBStart:activate     := {|| ::StartShow(), ::ShowBar()  }

RETURN self

******************************************************************************
* Systemresourcen anfordern
******************************************************************************
METHOD NewForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * Methode der Superklasse rufen
   ::_NewForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oSPColor1R:setNumLimits(0,255)
   ::oSPColor1G:setNumLimits(0,255)
   ::oSPColor1B:setNumLimits(0,255)
   ::oSPColor1R:setdata(255)
   ::oSPColor1G:setdata(000)
   ::oSPColor1B:setdata(000)

   ::oSPColor2R:setNumLimits(0,255)
   ::oSPColor2G:setNumLimits(0,255)
   ::oSPColor2B:setNumLimits(0,255)
   ::oSPColor2R:setdata(000)
   ::oSPColor2G:setdata(255)
   ::oSPColor2B:setdata(000)

   ::oSPColor3R:setNumLimits(0,255)
   ::oSPColor3G:setNumLimits(0,255)
   ::oSPColor3B:setNumLimits(0,255)
   ::oSPColor3R:setdata(000)
   ::oSPColor3G:setdata(000)
   ::oSPColor3B:setdata(255)

   ::oSPColor4R:setNumLimits(0,255)
   ::oSPColor4G:setNumLimits(0,255)
   ::oSPColor4B:setNumLimits(0,255)
   ::oSPColor4R:setdata(255)
   ::oSPColor4G:setdata(138)
   ::oSPColor4B:setdata(025)

   ::oColor1RGB:setcolorBG(GraMakeRGBColor(::aColor1))
   ::oColor2RGB:setcolorBG(GraMakeRGBColor(::aColor2))
   ::oColor3RGB:setcolorBG(GraMakeRGBColor(::aColor3))
   ::oColor4RGB:setcolorBG(GraMakeRGBColor(::aColor4))

   ::oV5Bar :hide()
   ::oV6BarH:hide()
   ::oV6BarV:hide()

   ::oPBStart:disable()

   ::CheckVersion()

   * Formular anzeigen
   ::show()

RETURN self

METHOD NewForm:StartShow()
LOCAL mlSetStyle
LOCAL oPS

   IF ::nVersion = 5
      ::oV6BarH:hide()
      ::oV6BarV:hide()
      ::oV5Bar:Show()
      ::oProgress := ::oV5Bar
      ::lSetStyle  := .T.

   ELSEIF ::nVersion = 6
      //
      // Version 6.x does not have Style ???
      //
      ::lSetStyle  := .F.

      IF ::lChkVert
         ::oV5Bar :hide()
         ::oV6BarH:hide()
         ::oV6BarV:Show()
         ::oProgress := ::oV6BarV
         ::oProgress:Orientation := XBPPRGR_ORIENT_VERT
         ::oProgress:setsize({24,416})

      ELSE
         ::oV5Bar :hide()
         ::oV6BarV:hide()
         ::oV6BarH:Show()
         ::oProgress := ::oV6BarH
         ::oProgress:Orientation := XBPPRGR_ORIENT_HORIZ

      ENDIF

   ENDIF
   //
   // now geht handle of Progessbar we use
   //
   ::hwndPB := ::oProgress:hWnd
   //
   // get original Style
   //
   ::OrgStyle := GetWindowLongA(::hwndPB, GWL_STYLE)


   IF ::nVersion = 5

      ::CheckSMOOTH()

   ELSEIF ::nVersion = 6
      IF ::lChksmooth
         ::oProgress:SetProperty("Scrolling", XBPPRGR_STYLE_SMOOTH )
      ELSE
         ::oProgress:SetProperty("Scrolling", XBPPRGR_STYLE_STANDARD )
      ENDIF
   ENDIF

   ::CheckVersion()
   ::CheckMarquee()

#IF XPPVER > 01900331

*   IF ::lSetStyle  = .T.

      ::oPreView:StyleClass   := ::cStyle
      ::oPreView:StylePart    := ::nPart
      ::oPreView:ControlState := XBP_STATE_PRESSED

      oPS := ::oPreView:LockPS()
      GraBackground( oPS, {0,0},::oPreView:CurrentSize() )
      ::oPreView:UnlockPS()

      ::oProgress:StyleClass   := ::cStyle
      ::oProgress:StylePart    := ::nPart
      ::oProgress:ControlState := XBP_STATE_PRESSED
*      ::oProgress:ControlState := XBP_STATE_HOT

      oPS := ::oProgress:LockPS()
      GraBackground( oPS, {0,0},::oProgress:CurrentSize() )
      ::oProgress:UnlockPS()

      ::oText:setcaption("Style "+ ::cStyle + " Part "+STR(::nPart) )

*   ELSE
*
*      ::oText:setcaption("Style disable")
*   ENDIF

#ELSE
   ::oText:setcaption( __XPP__+" does not support Visual Style "+STR(XPPVER) )

#ENDIF

   ::CheckColor()

   IF ::lChkColor  = .T.
   ELSE
      DO CASE
         CASE ::lRBnormal  ; ::NormalShow()
         CASE ::lRBerror   ; ::ErrorShow()
         CASE ::lRBpause   ; ::PauseShow()
      ENDCASE
   ENDIF
   //
   // some Property
   //
   ::oProgress:value := 0
   ::oProgress:Min   := 0
   ::oProgress:Max   := 100

RETURN self

METHOD NewForm:ShowBar()
LOCAL nValue
LOCAL nTime  := 3

   ::oProgress:Show()

   nValue := INT(::oProgress:Value)

   IF ::lChkMarquee
      SendMessageA(::hwndPB, PBM_SETSTATE   , PBST_PAUSED, 0)
      SendMessageA(::hwndPB, PBM_SETSTEP    , 100*nTime  , 0)
   ENDIF

   SendMessageA(::hwndPB, PBM_SETBARCOLOR, 0,;
      AutomationTranslateColor( GraMakeRGBColor(::aColor4),.F.) )

   DO WHILE .T.

      nValue++
      SLEEP(nTime)
      IF ::lChkMarquee
         SendMessageA(::hwndPB, PBM_STEPIT   , 1,   0)
      ENDIF

      IF nValue >= ::oProgress:Max
         EXIT
      ENDIF

      ::oProgress:Value := ( nValue )

      IF ((nValue+5) % 5) == 0
         ::oProz:setcaption(LTRIM(STR(nValue+5))+" %")
      ENDIF

      IF ::lChkColor

         IF ((nValue) % 25) == 0
            SendMessageA(::hwndPB, PBM_SETBARCOLOR, 0,;
               AutomationTranslateColor( GraMakeRGBColor(::aColor1),.F.) )
         ENDIF

         IF ((nValue) % 50) == 0
            SendMessageA(::hwndPB, PBM_SETBARCOLOR, 0,;
               AutomationTranslateColor( GraMakeRGBColor(::aColor2),.F.) )
         ENDIF

         IF ((nValue) % 75) == 0
            SendMessageA(::hwndPB, PBM_SETBARCOLOR, 0,;
               AutomationTranslateColor( GraMakeRGBColor(::aColor3),.F.) )
         ENDIF

         IF ((nValue+5) % 99) == 0
            ::oProz:setcaption("100 %")
            SendMessageA(::hwndPB, PBM_SETBARCOLOR, 0,;
               AutomationTranslateColor( GraMakeRGBColor(::aColor4),.F.) )
         ENDIF

      ENDIF

   ENDDO

   IF ::lChkMarquee
      SendMessageA(::hwndPB, PBM_SETMARQUEE , 0, 0)
   ENDIF

RETURN self

METHOD NewForm:SetTV(oItem)
LOCAL cStyle := ""
LOCAL cPart  := ""
LOCAL oPS

   cStyle := oItem:getParentItem():caption
   cPart  := oItem:caption

   IF EMPTY(cStyle)
      ::cStyle    := cPart
      ::nPart     := 1

      ::oPBStart:disable()

   ELSE
      cPart := STRTRAN(cPart,"Part","")

      ::cStyle    := cStyle
      ::nPart     := VAL(cPart)

#IF XPPVER > 01900331

      ::oPreView:StyleClass   := ::cStyle
      ::oPreView:StylePart    := ::nPart
      ::oPreView:ControlState := XBP_STATE_PRESSED

      oPS := ::oPreView:LockPS()
      GraBackground( oPS, {0,0},::oPreView:CurrentSize() )
      ::oPreView:UnlockPS()

      ::oText:setcaption("Style "+ ::cStyle + " Part "+STR(::nPart) )
#ELSE
      ::oText:setcaption( __XPP__+" does not support Visual Style "+STR(XPPVER) )
#ENDIF

      ::oPBStart:enable()
   ENDIF

RETURN self

METHOD NewForm:NormalShow()
   SendMessageA(::hwndPB, PBM_SETSTATE, PBST_NORMAL, 0)
RETURN self

METHOD NewForm:PauseShow()
   SendMessageA(::hwndPB, PBM_SETSTATE, PBST_PAUSED, 0)
RETURN self

METHOD NewForm:ErrorShow()
   SendMessageA(::hwndPB, PBM_SETSTATE, PBST_ERROR , 0)
RETURN self

METHOD NewForm:CheckColor()

   IF ::oChkcolor:getData() = .T.
      ::lChkColor  := .T.
      SetWindowLongA(::hwndPB, GWL_STYLE, ::OrgStyle)

   ELSE
      ::lChkColor  := .F.

   ENDIF

   IF ::lChkColor
      ::oStatColor:enable()

      ::aColor1 := { 255-::oSPColor1R:getdata(),;
                     255-::oSPColor1G:getdata(),;
                     255-::oSPColor1B:getdata() }

      ::aColor2 := { 255-::oSPColor2R:getdata(),;
                     255-::oSPColor2G:getdata(),;
                     255-::oSPColor2B:getdata() }

      ::aColor3 := { 255-::oSPColor3R:getdata(),;
                     255-::oSPColor3G:getdata(),;
                     255-::oSPColor3B:getdata() }

      ::aColor4 := { 255-::oSPColor4R:getdata(),;
                     255-::oSPColor4G:getdata(),;
                     255-::oSPColor4B:getdata() }

      ::oColor1RGB:setcolorFG(GraMakeRGBColor(::aColor1))
      ::oColor2RGB:setcolorFG(GraMakeRGBColor(::aColor2))
      ::oColor3RGB:setcolorFG(GraMakeRGBColor(::aColor3))
      ::oColor4RGB:setcolorFG(GraMakeRGBColor(::aColor4))


      ::aColor1 := { ::oSPColor1R:getdata(),;
                     ::oSPColor1G:getdata(),;
                     ::oSPColor1B:getdata() }

      ::aColor2 := { ::oSPColor2R:getdata(),;
                     ::oSPColor2G:getdata(),;
                     ::oSPColor2B:getdata() }

      ::aColor3 := { ::oSPColor3R:getdata(),;
                     ::oSPColor3G:getdata(),;
                     ::oSPColor3B:getdata() }

      ::aColor4 := { ::oSPColor4R:getdata(),;
                     ::oSPColor4G:getdata(),;
                     ::oSPColor4B:getdata() }

      ::oColor1RGB:setcolorBG(GraMakeRGBColor(::aColor1))
      ::oColor2RGB:setcolorBG(GraMakeRGBColor(::aColor2))
      ::oColor3RGB:setcolorBG(GraMakeRGBColor(::aColor3))
      ::oColor4RGB:setcolorBG(GraMakeRGBColor(::aColor4))

   ELSE
      ::oStatColor:disable()
   ENDIF

RETURN self

METHOD NewForm:CheckVersion()
LOCAL cOS_PRODUCT    := Os(OS_PRODUCT  )

   IF ::nVersion = 5

*      ::lSetStyle := .T.
      ::oChkMarquee:enable()

      ::oChkVert:disable()
      ::oChkreverse:disable()

      IF cOS_PRODUCT = "WINXP"
         ::oChksmooth:disable()

         ::oRBnormal:disable()
         ::oRBerror :disable()
         ::oRBpause :disable()

      ELSEIF cOS_PRODUCT = "WINVISTA"
         ::oChksmooth:enable()

         ::oRBnormal:enable()
         ::oRBerror :enable()
         ::oRBpause :enable()

      ENDIF

   ELSEIF ::nVersion = 6

*      ::lSetStyle := .F.
      ::oChkMarquee:disable()

      ::oChkVert:enable()
      ::oChksmooth:enable()
      ::oChkreverse:enable()
   ENDIF

RETURN self

METHOD NewForm:CheckSMOOTH()
LOCAL mlSetStyle

   IF ::oChksmooth:getdata() = .T. .OR. ::oChkreverse:getdata() = .T.

      IF ::oChkreverse:getdata() = .T.
         ::lChksmooth  := .T.
         ::lChkreverse := .T.
         mlSetStyle := BOr(WS_CHILD,WS_VISIBLE,PBS_SMOOTHREVERSE )
         mlSetStyle := SetWindowLongA(::hwndPB, GWL_STYLE, mlSetStyle)

      ELSE
         ::lChksmooth  := .T.
         ::lChkreverse := .F.
         mlSetStyle := BOr(WS_CHILD,WS_VISIBLE,PBS_SMOOTH )
         mlSetStyle := SetWindowLongA(::hwndPB, GWL_STYLE, mlSetStyle)
      ENDIF

   ELSE
      ::lChksmooth      := .F.
   ENDIF

RETURN self

METHOD NewForm:CheckMarquee()
LOCAL mlSetStyle

   IF ::oChkMarquee:getdata() = .T.

      mlSetStyle := BOr(WS_CHILD,WS_VISIBLE,PBS_MARQUEE )
      mlSetStyle := SetWindowLongA(::hwndPB, GWL_STYLE, mlSetStyle)

      SendMessageA(::hwndPB, PBM_SETMARQUEE , 1, 100)
      ::lChkMarquee := .T.

   ELSE

      SendMessageA(::hwndPB, PBM_SETMARQUEE , 0, 0)
      ::lChkMarquee := .F.

      IF NIL = ::OrgStyle
      ELSE
         mlSetStyle := SetWindowLongA(::hwndPB, GWL_STYLE, ::OrgStyle)
      ENDIF

   ENDIF


RETURN self

PROCEDURE AppSys
RETURN

******************************************************************************
* Main Prozedur zum Testen des Formulars
******************************************************************************
PROCEDURE Main
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg, oItem

   oDlg := NewForm():New()
   oDlg:Create()

   WorkAreaInfo( oDlg:oTree )

   oDlg:oTree:itemSelected := {| oItem, aRect, oSelf | oDlg:SetTV(oItem) }
   oDlg:oTree:rootItem:expand( .T. )
   oDlg:oTree:rootItem:setData("visual Styles")

   oItem := ChangeTree(oDlg:oTree:rootItem,"Progress","Part 1")

   oDlg:oTree:show()
   SetAppFocus( oDlg:oTree )

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

RETURN

** Baumstruktur fr jede Workarea aufbauen
PROCEDURE WorkAreaInfo( oTree )
LOCAL oArea, oItem
LOCAL i,imax
LOCAL j,jMax

   iMax := LEN(aStyles)
   oArea := oTree:rootItem:addItem( "visual Styles" )

   FOR i := 1 TO iMax
      // Erste Ebene im Baum beginnt bei oTree:rootItem
      oItem := oArea:addItem( AllTrim(aStyles[i][1]) )

      jMax := aStyles[i][2]
      FOR j := 1 TO jMax
         // XbpTreeViewItem erzeugen lassen (2. Mglichkeit)
         oItem:addItem( "Part"+STR(j,2) )
      NEXT
   NEXT
RETURN

FUNCTION ChangeTree(oParent,cSeek,cNext)
LOCAL nPos1 := 0
LOCAL nPos2 := 0
LOCAL oStyle
LOCAL aStyles
LOCAL oItem
LOCAL aItem


ALTD()

   oStyle := oParent:getChildItems()[1]

   aStyles := oStyle:getChildItems()
   nPos1 := ASCAN( aStyles , {|x| x:caption = cSeek} )
   IF nPos1 > 0
      oItem := aStyles[nPos1]
      aItem := oItem:getChildItems()
      nPos2 := ASCAN( aItem , {|x| x:caption = cNext } )
      IF nPos2 > 0
         aStyles[nPos1]:setData(cSeek)
         aItem[nPos2]:setData(cNext)
      ENDIF
   ENDIF

RETURN oItem


* Programmcode fr die Implementierungsebene der Klasse einfgen
#include "_PBAR01.PRG"

*
* eof
*

