///////////////////////////////////////////////////////////////////////////////
//
//  Vom Xbase++ FormDesigner generierter Klassen Code
//    Erstellt am: 20.09.08 Zeit: 10:12:22
//
//  Contents  :
//    Diese Datei enthlt die Implementierungsebene eines Formulares und
//    wird vom Xbase++ FormDesigner automatisch berschrieben. Sie sollte
//    niemals editiert werden, da die nderungen verloren gehen knnten.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _NEWFORM_
#define _NEWFORM_

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

#PRAGMA LIBRARY( "ASCOM10.LIB" )

CLASS _NewForm FROM XbpDialog
   EXPORTED:
      VAR editControls

      * Enthaltene Kontrollelemente
      VAR oV5Bar      
      VAR oV6BarH     
      VAR oV6BarV     
      VAR oProz       
      VAR oTree       
      VAR oChkVert    
      VAR oPBStart    
      VAR oChksmooth  
      VAR oChkMarquee 
      VAR oText       
      VAR oStatColor  
      VAR oSPColor1R  
      VAR oSPColor1G  
      VAR oSPColor1B  
      VAR oColor1RGB  
      VAR oSPColor2R  
      VAR oSPColor2G  
      VAR oSPColor2B  
      VAR oColor2RGB  
      VAR oSPColor3R  
      VAR oSPColor3G  
      VAR oSPColor3B  
      VAR oColor3RGB  
      VAR oSPColor4R  
      VAR oSPColor4G  
      VAR oSPColor4B  
      VAR oColor4RGB  
      VAR oChkreverse 
      VAR oStatRBcolor
      VAR oRBnormal   
      VAR oRBerror    
      VAR oRBpause    
      VAR oChkColor   
      VAR oStatVersion
      VAR oRB5        
      VAR oRB6        
      VAR oPreView    

      METHOD init
      METHOD create
ENDCLASS

******************************************************************************
* Formular initialisieren
******************************************************************************
METHOD _NewForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {250,64}, ;
           aSize    TO {432,600}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )
   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "Neues Formular"

   ::editControls := {}

   ::oV5Bar       := XbpActiveXControl():new( ::drawingArea, , {20,504}, {380,40} )
   ::oV5Bar:CLSID := "{0713E8D2-850A-101B-AFC0-4210102A8DA7}"
   ::oV5Bar:License := " qhj ZtuQha;jdfn[iaetr "
   ::oV5Bar:TabStop := .T.

   ::oV6BarH      := XbpActiveXControl():new( ::drawingArea, , {20,432}, {380,40} )
   ::oV6BarH:CLSID := "{35053A22-8589-11D1-B16A-00C0F0283628}"
   ::oV6BarH:License := "9368265E-85FE-11d1-8BE3-0000F8754DA1"
   ::oV6BarH:TabStop := .T.

   ::oV6BarV      := XbpActiveXControl():new( ::drawingArea, , {20,12}, {24,416} )
   ::oV6BarV:CLSID := "{35053A22-8589-11D1-B16A-00C0F0283628}"
   ::oV6BarV:License := "9368265E-85FE-11d1-8BE3-0000F8754DA1"
   ::oV6BarV:TabStop := .T.

   ::oProz        := XbpStatic():new( ::drawingArea, , {316,476}, {80,24}, { { XBP_PP_COMPOUNDNAME, "16.Arial" } } )
   ::oProz:caption := "0 %"
   ::oProz:clipSiblings := .T.
   ::oProz:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

   ::oTree        := XbpTreeView():new( ::drawingArea, , {48,12}, {180,412}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oTree:tabStop := .T.

   ::oChkVert     := XbpCheckBox():new( ::drawingArea, , {324,352}, {64,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oChkVert:caption := "vertical"
   ::oChkVert:tabStop := .T.
   ::oChkVert:selected := {|| NIL }

   ::oPBStart     := XbpPushButton():new( ::drawingArea, , {236,12}, {148,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oPBStart:caption := "Start"
   ::oPBStart:tabStop := .T.
   ::oPBStart:activate := {|| NIL }

   ::oChksmooth   := XbpCheckBox():new( ::drawingArea, , {324,328}, {64,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oChksmooth:caption := "smooth"
   ::oChksmooth:tabStop := .T.
   ::oChksmooth:selected := {|| NIL }

   ::oChkMarquee  := XbpCheckBox():new( ::drawingArea, , {324,276}, {64,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oChkMarquee:caption := "Marquee"
   ::oChkMarquee:tabStop := .T.
   ::oChkMarquee:selected := {|| NIL }

   ::oText        := XbpStatic():new( ::drawingArea, , {24,476}, {200,24} )
   ::oText:caption := "Style"
   ::oText:clipSiblings := .T.
   ::oText:options := XBPSTATIC_TEXT_VCENTER

   ::oStatColor   := XbpStatic():new( ::drawingArea, , {236,48}, {148,228} )
   ::oStatColor:caption := "RGB Color"
   ::oStatColor:clipSiblings := .T.
   ::oStatColor:type := XBPSTATIC_TYPE_GROUPBOX

   ::oSPColor1R   := XbpSpinButton():new( ::oStatColor, , {4,188}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor1R:bufferLength := 3
   ::oSPColor1R:tabStop := .T.

   ::oSPColor1G   := XbpSpinButton():new( ::oStatColor, , {52,188}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor1G:bufferLength := 3
   ::oSPColor1G:tabStop := .T.

   ::oSPColor1B   := XbpSpinButton():new( ::oStatColor, , {100,188}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor1B:bufferLength := 3
   ::oSPColor1B:tabStop := .T.

   ::oColor1RGB   := XbpStatic():new( ::oStatColor, , {4,168}, {140,20}, { { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oColor1RGB:caption := "Farbe 1"
   ::oColor1RGB:clipSiblings := .T.
   ::oColor1RGB:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

   ::oSPColor2R   := XbpSpinButton():new( ::oStatColor, , {4,136}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor2R:bufferLength := 3
   ::oSPColor2R:tabStop := .T.

   ::oSPColor2G   := XbpSpinButton():new( ::oStatColor, , {52,136}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor2G:bufferLength := 3
   ::oSPColor2G:tabStop := .T.

   ::oSPColor2B   := XbpSpinButton():new( ::oStatColor, , {100,136}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor2B:bufferLength := 3
   ::oSPColor2B:tabStop := .T.

   ::oColor2RGB   := XbpStatic():new( ::oStatColor, , {4,116}, {140,20}, { { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oColor2RGB:caption := "Farbe 2"
   ::oColor2RGB:clipSiblings := .T.
   ::oColor2RGB:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

   ::oSPColor3R   := XbpSpinButton():new( ::oStatColor, , {4,80}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor3R:bufferLength := 3
   ::oSPColor3R:tabStop := .T.

   ::oSPColor3G   := XbpSpinButton():new( ::oStatColor, , {52,80}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor3G:bufferLength := 3
   ::oSPColor3G:tabStop := .T.

   ::oSPColor3B   := XbpSpinButton():new( ::oStatColor, , {100,80}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor3B:bufferLength := 3
   ::oSPColor3B:tabStop := .T.

   ::oColor3RGB   := XbpStatic():new( ::oStatColor, , {4,60}, {140,20}, { { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oColor3RGB:caption := "Farbe 3"
   ::oColor3RGB:clipSiblings := .T.
   ::oColor3RGB:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

   ::oSPColor4R   := XbpSpinButton():new( ::oStatColor, , {4,24}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor4R:bufferLength := 3
   ::oSPColor4R:tabStop := .T.

   ::oSPColor4G   := XbpSpinButton():new( ::oStatColor, , {52,24}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor4G:bufferLength := 3
   ::oSPColor4G:tabStop := .T.

   ::oSPColor4B   := XbpSpinButton():new( ::oStatColor, , {100,24}, {44,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oSPColor4B:bufferLength := 3
   ::oSPColor4B:tabStop := .T.

   ::oColor4RGB   := XbpStatic():new( ::oStatColor, , {4,4}, {140,20}, { { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oColor4RGB:caption := "Farbe 4"
   ::oColor4RGB:clipSiblings := .T.
   ::oColor4RGB:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

   ::oChkreverse  := XbpCheckBox():new( ::drawingArea, , {324,304}, {72,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oChkreverse:caption := "smoothRev"
   ::oChkreverse:tabStop := .T.
   ::oChkreverse:selected := {|| NIL }

   ::oStatRBcolor := XbpStatic():new( ::drawingArea, , {236,300}, {68,92} )
   ::oStatRBcolor:caption := ""
   ::oStatRBcolor:clipSiblings := .T.
   ::oStatRBcolor:type := XBPSTATIC_TYPE_GROUPBOX

   ::oRBnormal    := XbpRadioButton():new( ::oStatRBcolor, , {4,52}, {60,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oRBnormal:caption := "Normal"
   ::oRBnormal:tabStop := .T.
   ::oRBnormal:selected := {|| NIL }

   ::oRBerror     := XbpRadioButton():new( ::oStatRBcolor, , {4,28}, {60,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oRBerror:caption := "Error"
   ::oRBerror:tabStop := .T.
   ::oRBerror:selected := {|| NIL }

   ::oRBpause     := XbpRadioButton():new( ::oStatRBcolor, , {4,4}, {60,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oRBpause:caption := "Pause"
   ::oRBpause:tabStop := .T.
   ::oRBpause:selected := {|| NIL }

   ::oChkColor    := XbpCheckBox():new( ::drawingArea, , {240,276}, {64,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oChkColor:caption := "Color"
   ::oChkColor:tabStop := .T.
   ::oChkColor:selected := {|| NIL }

   ::oStatVersion := XbpStatic():new( ::drawingArea, , {236,388}, {164,44} )
   ::oStatVersion:caption := ""
   ::oStatVersion:clipSiblings := .T.
   ::oStatVersion:type := XBPSTATIC_TYPE_GROUPBOX

   ::oRB5         := XbpRadioButton():new( ::oStatVersion, , {4,4}, {72,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oRB5:caption := "Version 5"
   ::oRB5:selection := .T.
   ::oRB5:tabStop := .T.
   ::oRB5:selected := {|| NIL }

   ::oRB6         := XbpRadioButton():new( ::oStatVersion, , {88,4}, {72,20}, { { XBP_PP_BGCLR, -255 } } )
   ::oRB6:caption := "Version 6"
   ::oRB6:selection := .T.
   ::oRB6:tabStop := .T.
   ::oRB6:selected := {|| NIL }

   ::oPreView     := XbpStatic():new( ::drawingArea, , {228,476}, {80,24} )
   ::oPreView:caption := ""
   ::oPreView:clipSiblings := .T.
   ::oPreView:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER

RETURN self


******************************************************************************
* Systemresourcen anfordern
******************************************************************************
METHOD _NewForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oV5Bar:create()

   ::oV6BarH:create()

   ::oV6BarV:create()

   ::oProz:create()

   ::oTree:create()

   ::oChkVert:create()

   ::oPBStart:create()

   ::oChksmooth:create()

   ::oChkMarquee:create()

   ::oText:create()

   ::oStatColor:create()

   ::oSPColor1R:create()

   ::oSPColor1G:create()

   ::oSPColor1B:create()

   ::oColor1RGB:create()

   ::oSPColor2R:create()

   ::oSPColor2G:create()

   ::oSPColor2B:create()

   ::oColor2RGB:create()

   ::oSPColor3R:create()

   ::oSPColor3G:create()

   ::oSPColor3B:create()

   ::oColor3RGB:create()

   ::oSPColor4R:create()

   ::oSPColor4G:create()

   ::oSPColor4B:create()

   ::oColor4RGB:create()

   ::oChkreverse:create()

   ::oStatRBcolor:create()

   ::oRBnormal:create()

   ::oRBerror:create()

   ::oRBpause:create()

   ::oChkColor:create()

   ::oStatVersion:create()

   ::oRB5:create()

   ::oRB6:create()

   ::oPreView:create()


RETURN self

#endif

//EOF
/////